
#include <ros/ros.h>
#include <actionlib/server/simple_action_server.h>

#include "pr2_gripper_click/GripperClickPickupAction.h"
#include "pr2_gripper_click/GripperClickPlaceAction.h"

class ActionTest
{

public:
 
  actionlib::SimpleActionServer<pr2_gripper_click::GripperClickPickupAction> *pickup_action_server_;  

  actionlib::SimpleActionServer<pr2_gripper_click::GripperClickPlaceAction> *place_action_server_;

  ros::NodeHandle update_nh_;

  void pickupActionCallback(const pr2_gripper_click::GripperClickPickupGoal::ConstPtr &goal)
  {
    ROS_INFO("Received goal");
    pr2_gripper_click::GripperClickPickupResult result;
    pickup_action_server_->setAborted(result);
    ROS_INFO("Goal aborted");
  }

  void placeActionCallback(const pr2_gripper_click::GripperClickPlaceGoal::ConstPtr &goal)
  {
  }

  ActionTest() : update_nh_("")
  {
    pickup_action_server_ = new actionlib::SimpleActionServer<pr2_gripper_click::GripperClickPickupAction>(update_nh_, 
                                                                                        "gripper_click_pickup_ui", 
                                                 boost::bind(&ActionTest::pickupActionCallback, this, _1));
    ROS_INFO("Pickup action server started");

    //place_action_server_ = new actionlib::SimpleActionServer<pr2_gripper_click::GripperClickPlaceAction>(update_nh_, 
    //                                                                                  "gripper_click_place_ui", 
    //					    boost::bind(&ActionTest::placeActionCallback, this, _1));
  //ROS_INFO("Place action server started");    
  }

  ~ActionTest()
  {
    delete pickup_action_server_; pickup_action_server_ = NULL;
    //delete place_action_server_; place_action_server_ = NULL;
    ROS_INFO("Action servers deleted");
  }
};

int main(int argc, char **argv)
{
  ros::init(argc, argv, "test_actions");
  ActionTest at;
  ros::spin();
}
